SystemOrganization addCategory: #'Mentor-UI'!

RecommendationsFacade subclass: #RecommendationsMentorFacade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mentor-UI'!

!RecommendationsMentorFacade class methodsFor: 'framework' stamp: 'AndyKellens 9/27/2012 15:15'!
getMissingForEntity: anEntity
	| rulesAndProperties rules properties rulesWithMissing  groupedByMissingProperty result |
	rulesAndProperties := AbstractCodeMiner rulesAndPropertiesForEntity: anEntity.
	rules := rulesAndProperties key.
	properties := rulesAndProperties value.
	rulesWithMissing := rules select:[:rule |
		((rule condition intersection: properties) size = (rule condition size)) and:[
			(rule conclusion intersection: properties) size < (rule conclusion size)]].
	groupedByMissingProperty := Dictionary new.
	rulesWithMissing do:[:rule |
		(rule conclusion reject: [:property | properties includes: property]) do:[:property | (groupedByMissingProperty at: property ifAbsentPut:[Set new]) add: rule]].
	result := OrderedCollection new.
	groupedByMissingProperty keysAndValuesDo: [:property :matchingRules |
		result add:(OBMissingNode property: property rules: matchingRules fromTool: #Mentor)].
	^result
	
	! !

!RecommendationsMentorFacade class methodsFor: 'framework' stamp: 'AndyKellens 9/27/2012 15:25'!
getSuggestedForEntity: anEntity
	| rulesAndProperties rules properties rulesWithSuggested  groupedBySuggestedProperty result |
	rulesAndProperties := AbstractCodeMiner rulesAndPropertiesForEntity: anEntity.
	rules := rulesAndProperties key.
	properties := rulesAndProperties value.
	rulesWithSuggested := rules select:[:rule |
		((rule condition intersection: properties) size < (rule condition size)) and:[
			(rule conclusion intersection: properties) size = (rule conclusion size)]].
	groupedBySuggestedProperty := Dictionary new.
	rulesWithSuggested do:[:rule |
		(rule condition reject: [:property | properties includes: property]) do:[:property | (groupedBySuggestedProperty at: property ifAbsentPut:[Set new]) add: rule]].
	result := OrderedCollection new.
	groupedBySuggestedProperty keysAndValuesDo: [:property :matchingRules |
		result add:(OBSuggestedNode property: property rules: matchingRules fromTool: #Mentor)].
	^result
	
	! !
